#include <stdio.h>
#include <stdlib.h>
#include <vector>

using namespace std;

int n, x, y, ans;
vector<pair<int, int> > c;
vector<int> s;
vector<bool> used;

inline int sign(int n)
{
    if (n > 0)
        return 1;
    else if (n < 0)
        return -1;
    else
        return 0;
}

inline void coeffs(pair<int, int> a1, pair<int, int> a2, long long &ca, long long &cb, long long &cc)
{
    ca = a1.second - a2.second;
    cb = a2.first - a1.first;
    cc = a1.first * a2.second - a1.second * a2.first;
}

inline bool intersect(pair<int, int> a1, pair<int, int> a2, pair<int, int> b1, pair<int, int> b2)
{
    long long ca, cb, cc, da, db, dc;
    coeffs(a1, a2, ca, cb, cc);
    coeffs(b1, b2, da, db, dc);
    if (ca * db == cb * da)
    {
        if (ca * dc != cc * da || cb * dc != cc * db)
           return false;
        else
        {
            int l1, m1, l2, m2;
            if (a1.first != a2.first)
            {
                l1 = min(a1.first, a2.first), l2 = max(a1.first, a2.first);
                m1 = min(b1.first, b2.first), m2 = max(b1.first, b2.first);
            }
            else
            {
                l1 = min(a1.second, a2.second), l2 = max(a1.second, a2.second);
                m1 = min(b1.second, b2.second), m2 = max(b1.second, b2.second);
            }
            return !(m2 <= l1 || m1 >= l2);
        }
    } else
    {
        int pb1 = sign(ca * b1.first + cb * b1.second + cc);
        int pb2 = sign(ca * b2.first + cb * b2.second + cc);
        int pa1 = sign(da * a1.first + db * a1.second + dc);
        int pa2 = sign(da * a2.first + db * a2.second + dc);
        switch (pb1 * pb2)
        {
            case 1:
                return false;
            case -1:
                return pa1 * pa2 <= 0;
            case 0:
                return pa1 * pa2 == -1;
        }
    }
}

int wrong(char* issue)
{
    printf("%d - ", 0);
    printf(issue);
    return 1;
}

int correct(int maxPoints)
{
    printf("%d - ", maxPoints);
    printf("ok");
    return 0;
}

int main(int argc, char **argv)
{
    freopen(argv[4], "r", stdin);
    scanf("%d", &ans);

    if (ans)
    {
        freopen(argv[2], "r", stdin);
        scanf("%d", &n);
        for (int i = 0; i < n; i++)
        {
            scanf("%d %d", &x, &y);
            c.push_back(make_pair(x, y));
        }
        used.resize(n, false);
    }

    freopen("report", "w", stdout);
    freopen(argv[3], "r", stdin);

    if (ans)
    {
        for (int i = 0; i < n; i++)
        {
            if (!scanf("%d", &x))
               return wrong("reading issue");
            if (x < 1 || x > n)
               return wrong("out of range");
            if (used[x - 1])
               return wrong("used twice");
            used[x - 1] = true;
            s.push_back(x - 1);
        }
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                if (intersect(c[s[i]], c[s[(i + 1) % n]], c[s[j]], c[s[(j + 1) % n]]))
                   return wrong("intersection");
    }
    else
    {
        if (!scanf("%d", &x) || x != 0)
           return wrong("not possible");
    }
    return correct(atoi(argv[1]));
}
